<?php
namespace App\Controller;

use Psr\Http\Message\ResponseInterface as Response;
use Psr\Http\Message\ServerRequestInterface as Request;

class Consumer {

    private $consumerService;
    private $util;

    public function __construct(
        \App\Service\Consumer $consumerService,
        \App\Util\Util $util
    ) {

        $this->consumerService = $consumerService;
        $this->util = $util;
    }

    public function getConsumersByPhone(Request $request, Response $response) {
        try {
            $params = $request->getParsedBody();
            
            
            $NRTELEFONE = $params['NRTELEFONE'];
            
            $dataset = $this->consumerService->getConsumersByPhone($NRTELEFONE);

            $response->getBody()->write(json_encode([
                'error' => false,
                'message' => '',
                'data' => $dataset
            ]));
    
            return $response->withHeader('Content-Type', 'application/json');
        } catch (\Exception $e) {
            $response->getBody()->write(json_encode([
                'error'   => true,
                'message' => $e->getMessage(),
                'data'    => []
            ]));

            return $response->withHeader('Content-Type', 'application/json');
        }
    }

    public function getConsumerAddresses(Request $request, Response $response) {
        try {
            $params = $request->getParsedBody();

            $CDCLIENTE = $params['CDCLIENTE'];
            $CDCONSUMIDOR = $params['CDCONSUMIDOR'];
            
            $dataset = $this->consumerService->getConsumerAddresses($CDCLIENTE, $CDCONSUMIDOR);

            $response->getBody()->write(json_encode([
                'error' => false,
                'message' => '',
                'data' => $dataset
            ]));
    
            return $response->withHeader('Content-Type', 'application/json');
        } catch (\Exception $e) {
            $response->getBody()->write(json_encode([
                'error'   => true,
                'message' => $e->getMessage(),
                'data'    => []
            ]));

            return $response->withHeader('Content-Type', 'application/json');
        }
    }


}