<?php
namespace App\Util;

use \Datetime;

class DateUtil {
    public function isLastMonth($date) {
        $today = new DateTime();
        $lastMonth = $today->modify('-1 month');
        $lastMonth = $lastMonth->format('m');
        $date = DateTime::createFromFormat('d/m/Y H:i:s', $date);
        $monthDate = $date->format('m');
        return ($monthDate == $lastMonth);
    }

    public function isCurrentMonth($date) {
        $today = new DateTime();
        $date = DateTime::createFromFormat('d/m/Y H:i:s', $date);
        $monthDate = $date->format('m');
        $monthToday = $today->format('m');
        return ($monthDate == $monthToday);
    }

    public function isLastWeek($date) {
        $today = new DateTime();
        $today->setTime(0, 0, 0);
        $date = DateTime::createFromFormat('d/m/Y H:i:s', $date);
        $date->setTime(0, 0, 0);
        $daysDiff = $today->diff($date)->days;
        return ($daysDiff > 0 && $daysDiff < 8);
    }

    public function isToday($date) {
        $today = new DateTime();
        $date = DateTime::createFromFormat('d/m/Y H:i:s', $date);
        $today = $today->format('d-m-Y');
        $date = $date->format('d-m-Y');
        return ($today == $date);
    }

    public function getAllMonthNames() {
        return ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro',
          'Outubro', 'Novembro', 'Dezembro'];
    }

    public function getPreviousMonths($months, $includeCurrentMonth = false) {
        $previousMonths = [];
        $monthNames = $this->getAllMonthNames();
        $reversedMonthNames = array_reverse($monthNames);
        $monthsInYear = 12;
        $currentMonthIdx = date('n') - 1;
        $currentMonth = $monthNames[$currentMonthIdx];
        $result = [];
        $monthIdx = $monthsInYear - $currentMonthIdx;
    
        $isLastMonthIdx = function($idx) use ($monthNames) {
            return $idx === count($monthNames);
        };
    
        while (intval(count($previousMonths)) < intval($months)) {
            if ($isLastMonthIdx($monthIdx)) {
                $monthIdx = 0;
            }
            $previousMonths[] = $reversedMonthNames[$monthIdx];
            $monthIdx += 1;
        }
    
        $result = array_reverse($previousMonths);
    
        if ($includeCurrentMonth) {
            $result[] = $currentMonth;
        }
    
        return $result;
    }

    public function getWeekDay($dayCode) {
        $days = array(
            '1' => 'Domingo',
            '2' => 'Segunda-Feira',
            '3' => 'Terça-Feira',
            '4' => 'Quarta-Feira',
            '5' => 'Quinta-Feira',
            '6' => 'Sexta-Feira',
            '7' => 'Sábado',
            'T' => 'Todos'
        );

        return $days[$dayCode];
    }
}

