import DateTime from '@/helpers/DateTime';

class DateRange {
  static completeDateRangeOrEmpty(config: any) {
    return (value: any) => {
      if (value) return [0, 2].includes(value.length);
      if (!value) return true;
      return config.message;
    };
  }

  static maximumAllowedRange(config: any) {
    return (value: any) => {
      let difference = 0;
      if (value) {
        difference = DateTime.difference(value[1], value[0],
          { typeFormatDefault: 'DD/MM/YYYY', unit: 'month' });
      }
      return difference < config.limit || config.message;
    };
  }
}

const { completeDateRangeOrEmpty, maximumAllowedRange } = DateRange;

const DateRangeValidations = {
  completeDateRangeOrEmpty,
  maximumAllowedRange,
};

export { DateRangeValidations };
